unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, math;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Panel1: TPanel;
    Button1: TButton;
    Label1: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Label2: TLabel;
    Button2: TButton;
    Button3: TButton;
    Label3: TLabel;
    Edit3: TEdit;
    Label4: TLabel;
    Edit4: TEdit;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    hoja  : TCanvas;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// create
procedure TForm1.FormCreate(Sender: TObject);
begin
  Edit2.Text := '3';
  hoja := Image1.Canvas;
end;

// limpiar
procedure TForm1.Button2Click(Sender: TObject);
begin
  hoja.Rectangle(-1,-1,Image1.Width+1,Image1.Height+1);
end;

// Circulo o poligonos
procedure TForm1.Button1Click(Sender: TObject);
var
  R, n, k : integer;
  err     : integer;
  xc,yc   : integer;
  x ,y    : integer;
  dth,th  : single;
begin
  R := StrToInt(Edit1.Text); // lectura directa

  val(Edit2.Text,n,err);  // lectura con validacin
  if (err<>0) then begin
    ShowMessage('Error en N, en la posicin '+IntToStr(err));
    exit;
  end;

  xc := Image1.Width  div 2;
  yc := Image1.Height shr 1;

  th  := 0.0;
  dth := 2*Pi/n;

  x := ceil(xc + 1.2*R);
  y := yc;

  hoja.MoveTo(x,y);

  for k := 0 to n - 1 do begin
    th := th + dth;
    x  := ceil(xc + 1.2*R*cos(th));
    y  := ceil(yc + R*sin(th));
    hoja.LineTo(x,y);
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  a,b,n,k,j : integer;
  err       : integer;
  xc,yc     : integer;
  x ,y      : integer;
  dth,th    : single;
begin
  a := StrToInt(Edit3.Text); // lectura directa
  b := StrToInt(Edit4.Text); // lectura directa

  val(Edit2.Text,n,err);  // lectura con validacin
  if (err<>0) then begin
    ShowMessage('Error en N, en la posicin '+IntToStr(err));
    exit;
  end;

  xc := Image1.Width  div 2;
  yc := Image1.Height shr 1;

  th  := 0.0;
  dth := 2*Pi/n;

  x := xc + a;
  y := yc ;

  hoja.MoveTo(x,y);

  hoja.Pen.Color :=  random($FFFFFF);
  for j := 0 to 29 do begin
    for k := 0 to n - 1 do begin
      th := th + dth;
      x  := ceil(xc + a*cos(th));
      y  := ceil(yc + b*sin(th));
      hoja.LineTo(x,y);
    end;
    b := b - 5;
    a := a + 5;
    th := 0.0;
    sleep(200);
    Image1.Refresh;
  end;
end;

end.
